#include "RKData.h"

class CsolveHH : public CRKData
{
public:
	CsolveHH();
	~CsolveHH();
public:
	void rhs(double x, double* yt, double* k);
	void initValues();

private:
	double Cm;     //   20.0 pF
	double Dm;     //   60.0 micrometer, diameter of the cell
	double Lm;     //   70.0 micrometer, length of the cell

	double Iinj;   // 2000.0 (pA)
	double Ton;    //   20 ms
	double Toff;   //   40 ms

	double Eleak;  //  -65.0 mV
	double ENa;    //   50.0 mV
	double EK;     // -100.0 mV
	double ECa;    //   50.0 mV

	double dGleak; //    0.002 mS/cm^2
	double dGNa;   //    0.53 mS/cm^2
	double dGK;    //    0.13 mS/cm^2
	double dGTCa;  //    0.03 mS/cm^2

	double vtraub; //  -55.0 mV

	double Am;     //  surface area
	double InvCm;  //  1/Cm;

	double Gleak;
	double GNa;
	double GK;
	double GTCa;
	double fac;    // conversion factor (mS/cm^2) -> (pS/micrometer^2)

private:
	void get_Na_m(double* tau, double* inf);
	void get_Na_h(double* tau, double* inf);
	void get_K_n(double* tau, double* inf);
	void get_TCa_m(double* tau, double* inf);
	void get_TCa_h(double* tau, double* inf);
};
